<!DOCTYPE html>
<html lang="en">
	<head>
		<title>Task 150 post lists</title>
		<meta charset="utf-8" />
		<meta name="viewport" content="width=device-width, initial-scale=1" />
		<link
			rel="stylesheet"
			href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
		/>
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
		<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
		<style>
			.width {
				width: 15%;
			}
			.jumbotron {
				padding: 2rem 2rem;
			}
		</style>
	</head>

	<body>
		<div class="container">
			<div class="text-center my-4">
				<h3 class="text-info">DANH SÁCH NGƯỜI DÙNG</h3>
			</div>
			<div class="row form-group">
				<div class="col-sm-12 d-flex justify-content-around jumbotron">
					<label class="form-label mr-5">Name: </label>
					<input type="text" class="form-control" id="inp-name" />
					<button id="btn-loc" class="btn btn-success ml-5 width">
						Lọc User
					</button>
				</div>
			</div>
			<table
				class="table table-bordered table-striped table-hover text-center"
				id="tbl-user-posts"
			>
				<thead>
					<tr>
						<th>STT</th>
						<th>Name</th>
						<th>Username</th>
						<th>Email</th>
						<th>Address</th>
						<th>Zip code</th>
						<th>Phone</th>
						<th>Company</th>
						<th>Action</th>
					</tr>
				</thead>
				<tbody></tbody>
			</table>
		</div>

		<script>
			'use strict';

			/*** REGION 1 - Global variables - Vùng khai báo hằng số, tham số TOÀN CỤC */
			const gCOL_POSTID = 0;
			const gCOL_POSTTITLE = 1;
			const gCOL_POSTEMAIL = 2;
			const gCOL_POSTBODY = 3;
			const gCOL_ACTION = 4;
			let gRespone = [];
			/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
			$(document).ready(function () {
				//gán event handler cho nút
				onPageloading();
			});
			$('#btn-loc').click(function () {
				onBtnFilterClick();
			});
			/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
			// hàm xử lý sự kiện lấy post của người dùng (4 bước xử lý)

			function onPageloading() {
				// thu thập dữ liệu(không cần)
				// kiểm tra dữ liệu(không cần)
				// gọi api

				$.ajax({
					url: 'https://jsonplaceholder.typicode.com/users/',
					type: 'GET',
					dataType: 'json', // added data type
					success: function (responseObject) {
						gRespone = responseObject;
						console.log(JSON.stringify(responseObject)); //response text
						//4 xử lý hiện thị
						loadTableUserPostData(responseObject); // responseObject là array các posts
					},
					error: function (ajaxContext) {
						alert(ajaxContext.responseText);
					},
				});
			}

			//hàm xử lý sự kiện click button detail
			function onDetailButtonClick(paramSuKienClick) {
				console.log(
					'%cDetail button click. Sự kiện Click là: ....',
					'color:orange'
				);
				var vButtonBiAn = paramSuKienClick.currentTarget;
				var vId = $(vButtonBiAn).data('id');
				console.log('id : ' + vId);

				const vFORM_TO_OPEN = 'userDetail.html'; //đây là form sẽ mở
				var vUrlToOpenPage = vFORM_TO_OPEN + '?' + 'id=' + vId;
				window.location.href = vUrlToOpenPage;
			}
			function onBtnFilterClick() {
				var vNameObj = {
					name: '',
				};

				getNameObj(vNameObj);
				var vFiterName = filterNameObj(vNameObj);
				if (vFiterName === false) {
					alert('không tìm thấy user');
				} else {
					resetTableData();
					loadTableUserPostData(vFiterName);
				}
			}
			/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
			//hàm reset (xóa) dữ liệu của bảng user
			function resetTableData() {
				$('#tbl-user-posts tbody').html(''); //truy câp bảng, rồi truy cập tbody, và xóa hết
			}

			//hàm load dữ liệu lên table
			function loadTableUserPostData(paramPosts) {
				//xóa dữ liệu của bảng
				//đổ dữ liệu
				for (var bI = 0; bI < paramPosts.length; bI++) {
					var bAddress = paramPosts[bI].address;
					//tạo row
					var bNewRow = $('<tr>').appendTo($('#tbl-user-posts  tbody'));
					// tao cell
					$('<td>').html(paramPosts[bI].id).appendTo(bNewRow); //append vào hàng mới

					$('<td>').html(paramPosts[bI].name).appendTo(bNewRow);

					$('<td>').html(paramPosts[bI].username).appendTo(bNewRow);

					$('<td>').html(paramPosts[bI].email).appendTo(bNewRow);

					$('<td>')
						.html(bAddress.street + bAddress.suite + bAddress.city)
						.appendTo(bNewRow);

					$('<td>').html(bAddress.zipcode).appendTo(bNewRow);

					$('<td>').html(paramPosts[bI].phone).appendTo(bNewRow);

					$('<td>').html(paramPosts[bI].company.name).appendTo(bNewRow);

					// xử lý cột action (có nút)
					var bColAction = $('<td>').addClass('btn-group').appendTo(bNewRow); //cột action
					/* nút chi tiết */
					var bDetailButton = $('<button>', { html: 'Chi tiết' })
						.addClass('btn btn-info')
						.data('id', paramPosts[bI].id)
						.appendTo(bColAction);
					// thêm sự kiện cho nút này
					bDetailButton.click(onDetailButtonClick);
				}
			}
			function getNameObj(paramObj) {
				paramObj.name = $('#inp-name').val().trim();
				console.log(paramObj);
			}

			function filterNameObj(paramObj) {
				let vResult = [];
				for (var bI = 0; bI < gRespone.length; bI++) {
					if (paramObj.name.toUpperCase() === gRespone[bI].name.toUpperCase()) {
						vResult.push(gRespone[bI]);
					}
				}
				if (vResult.length > 0) {
					return vResult;
				} else {
					return false;
				}
			}
		</script>
	</body>
</html>
